DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Stepper - Overview

The DevExtreme JavaScript Stepper allows you to indicate progress within a multi-step process and allows users to navigate between individual steps. Use our JavaScript Stepper to implement multi-page navigation in lengthy forms such as store/cart checkout.

To get started with DevExtreme JavaScript Stepper, refer to the following step-by-step tutorial: Getting Started with JavaScript Stepper.

Backend API
$(() => { const stepperWithIcons = $('#icons').dxStepper({ linear: navigationModes[0].value, elementAttr: { 'aria-labelledby': 'iconsLabel' }, selectedIndex: 2, dataSource, }).dxStepper('instance'); const stepperWithNumbers = $('#numbers').dxStepper({ linear: navigationModes[0].value, elementAttr: { 'aria-labelledby': 'numbersLabel' }, selectedIndex: 2, dataSource: dataSource.map(({ icon, text, ...rest }) => rest), }).dxStepper('instance'); const stepperWithCustomText = $('#customText').dxStepper({ linear: navigationModes[0].value, elementAttr: { 'aria-labelledby': 'customTextLabel' }, selectedIndex: 2, dataSource: dataSource.map(({ icon, label, optional, ...rest }) => rest), }).dxStepper('instance'); $('#orientation').dxButtonGroup({ width: '100%', items: orientations, selectedItems: [orientations[0]], onSelectionChanged(data) { const $widgetWrapper = $('.widget-wrapper'); const { text, value } = data.addedItems[0]; const isVertical = text === 'Vertical'; $widgetWrapper.toggleClass('widget-wrapper-vertical', isVertical); $widgetWrapper.toggleClass('widget-wrapper-horizontal', !isVertical); setOption('orientation', value); }, }); $('#navigationMode').dxButtonGroup({ width: '100%', items: navigationModes, selectedItems: [navigationModes[0]], onSelectionChanged(data) { setOption('linear', data.addedItems[0].value); }, }); $('#selectOnFocus').dxCheckBox({ text: 'Select step on focus', value: true, onValueChanged(data) { setOption('selectOnFocus', data.value); }, }); $('#rtlMode').dxCheckBox({ text: 'Right-to-left mode', value: false, onValueChanged(data) { setOption('rtlEnabled', data.value); }, }); function setOption(option, value) { stepperWithIcons.option(option, value); stepperWithNumbers.option(option, value); stepperWithCustomText.option(option, value); } });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" /> <script src="js/dx.all.js?v=26.1.4"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div class="stepper-demo"> <div class="widget-container"> <div class="widget-wrapper widget-wrapper-horizontal"> <div class="stepper-wrapper"> <div id="iconsLabel" class="stepper-label">Icons and Labels</div> <div id="icons"></div> </div> <div class="stepper-wrapper"> <div id="numbersLabel" class="stepper-label">Numbers and Labels</div> <div id="numbers"> </div> </div> <div class="stepper-wrapper"> <div id="customTextLabel" class="stepper-label">Custom Text</div> <div id="customText"></div> </div> </div> </div> <div class="options"> <div class="caption">Options</div> <div class="option"> <div>Orientation</div> <div id="orientation"></div> </div> <div class="option"> <div>Navigation Mode</div> <div id="navigationMode"></div> </div> <div class="option-separator"></div> <div class="option"> <div id="selectOnFocus"></div> </div> <div class="option"> <div id="rtlMode"></div> </div> </div> </div> </div> </body> </html>
.stepper-demo { display: flex; height: 580px; gap: 20px; } .widget-container { display: flex; align-items: center; justify-content: center; width: calc(100% - 280px); min-width: 320px; overflow: clip; } .widget-wrapper { display: inline-flex; flex-direction: column; align-items: center; justify-content: center; row-gap: 80px; width: 100%; } .widget-wrapper-vertical { display: flex; flex-direction: row; justify-content: space-around; } .widget-wrapper-vertical .stepper-wrapper { width: auto; max-width: 33%; } .widget-wrapper-vertical .stepper-label { text-align: center; white-space: nowrap; } .widget-wrapper-vertical #customText { width: auto; } .dx-stepper-vertical { height: 400px; width: 100%; } .stepper-wrapper { width: 100%; display: flex; flex-direction: column; align-items: center; gap: 16px; } .stepper-label { font-weight: 600; } .options { display: flex; flex-direction: column; flex-shrink: 0; width: 300px; box-sizing: border-box; padding: 20px; background-color: rgba(191, 191, 191, 0.15); gap: 16px; } .caption { font-weight: 500; font-size: 18px; } .option { display: flex; flex-direction: column; row-gap: 4px; } .option-separator { border-bottom: 1px solid var(--dx-color-border); } .dx-buttongroup .dx-button { width: 50%; }
const dataSource = [ { text: 'A', label: 'Cart', icon: 'cart', }, { text: 'B', label: 'Shipping Info', icon: 'clipboardtasklist', }, { text: 'C', label: 'Promo Code', icon: 'gift', optional: true, }, { text: 'D', label: 'Checkout', icon: 'packagebox', }, { text: 'E', label: 'Ordered', icon: 'checkmarkcircle', }, ]; const orientations = [ { text: 'Horizontal', value: 'horizontal' }, { text: 'Vertical', value: 'vertical' }, ]; const navigationModes = [ { text: 'Non-linear', value: false }, { text: 'Linear', value: true }, ];

Component Configuration

The following settings are available to you:

  • orientation (default: horizontal)
    JavaScript Stepper orientation (horizontal or vertical).

  • linear (default: true)
    Specifies whether users must navigate the JavaScript Stepper sequentially or can skip steps.

  • selectOnFocus (default: true)
    Specifies whether steps focused with keyboard navigation are selected automatically.

  • rtlEnabled (default: false)
    Switches the JavaScript Stepper to Right-to-Left mode.

Step Settings

To add steps, populate the items collection or specify a dataSource.

Use the following properties to customize steps:

  • text
    Indicator text. If you do not define this option, JavaScript Stepper numbers steps sequentially.

  • icon
    Indicator icon. JavaScript Stepper prioritizes icons over the text property.

  • label
    Step caption displayed next to the indicator.

  • optional
    Adds an (Optional) label to the step.

  • isValid
    Allows you to indicate step-related validation errors.

  • disabled
    Deactivates the step.

  • hint
    Tooltip text for the step.

  • template
    Allows you to customize step-related appearance. This property overrides all other step settings.

import React, { useState } from 'react';
import type { ButtonGroupTypes } from 'devextreme-react/button-group';
import type { CheckBoxTypes } from 'devextreme-react/check-box';
import type { Orientation } from 'devextreme-react/common';
import { navigationModes, orientations } from './data.ts';
import Steppers from './Steppers.tsx';
import Options from './Options.tsx';
export default function App() {
const [orientation, setOrientation] = useState<Orientation>(orientations[0].value);
const [navigationMode, setNavigationMode] = useState<boolean>(navigationModes[0].value);
const [selectOnFocus, setSelectOnFocus] = useState<boolean>(true);
const [rtlMode, setRtlMode] = useState<boolean>(false);
const onOrientationClick = (e: ButtonGroupTypes.ItemClickEvent): void => {
setOrientation(e.itemData.value);
};
const onNavigationModeClick = (e: ButtonGroupTypes.ItemClickEvent): void => {
setNavigationMode(e.itemData.value);
};
const onSelectOnFocusChanged = (e: CheckBoxTypes.ValueChangedEvent): void => {
setSelectOnFocus(e.value);
};
const onRtlModeChanged = (e: CheckBoxTypes.ValueChangedEvent): void => {
setRtlMode(e.value);
};
const widgetWrapperOrientationClass: string = `widget-wrapper-${orientation}`;
return (
<div className="stepper-demo">
<div className="widget-container">
<div className={`widget-wrapper ${widgetWrapperOrientationClass}`}>
<Steppers
orientation={orientation}
navigationMode={navigationMode}
selectOnFocus={selectOnFocus}
rtlMode={rtlMode}
/>
</div>
</div>
<div className="options">
<Options
orientation={orientation}
navigationMode={navigationMode}
selectOnFocus={selectOnFocus}
rtlMode={rtlMode}
onOrientationClick={onOrientationClick}
onNavigationModeClick={onNavigationModeClick}
onSelectOnFocusChanged={onSelectOnFocusChanged}
onRtlModeChanged={onRtlModeChanged}
/>
</div>
</div>
);
}
import React, { useState } from 'react';
import { navigationModes, orientations } from './data.js';
import Steppers from './Steppers.js';
import Options from './Options.js';
export default function App() {
const [orientation, setOrientation] = useState(orientations[0].value);
const [navigationMode, setNavigationMode] = useState(navigationModes[0].value);
const [selectOnFocus, setSelectOnFocus] = useState(true);
const [rtlMode, setRtlMode] = useState(false);
const onOrientationClick = (e) => {
setOrientation(e.itemData.value);
};
const onNavigationModeClick = (e) => {
setNavigationMode(e.itemData.value);
};
const onSelectOnFocusChanged = (e) => {
setSelectOnFocus(e.value);
};
const onRtlModeChanged = (e) => {
setRtlMode(e.value);
};
const widgetWrapperOrientationClass = `widget-wrapper-${orientation}`;
return (
<div className="stepper-demo">
<div className="widget-container">
<div className={`widget-wrapper ${widgetWrapperOrientationClass}`}>
<Steppers
orientation={orientation}
navigationMode={navigationMode}
selectOnFocus={selectOnFocus}
rtlMode={rtlMode}
/>
</div>
</div>
<div className="options">
<Options
orientation={orientation}
navigationMode={navigationMode}
selectOnFocus={selectOnFocus}
rtlMode={rtlMode}
onOrientationClick={onOrientationClick}
onNavigationModeClick={onNavigationModeClick}
onSelectOnFocusChanged={onSelectOnFocusChanged}
onRtlModeChanged={onRtlModeChanged}
/>
</div>
</div>
);
}
import React from 'react';
import { ButtonGroup, type ButtonGroupTypes } from 'devextreme-react/button-group';
import { CheckBox, type CheckBoxTypes } from 'devextreme-react/check-box';
import { type Orientation } from 'devextreme-react/common';
import { navigationModes, orientations } from './data.ts';
interface OptionsProps {
orientation: Orientation,
navigationMode: boolean,
selectOnFocus: boolean,
rtlMode: boolean,
onOrientationClick: (e: ButtonGroupTypes.ItemClickEvent) => void;
onNavigationModeClick: (e: ButtonGroupTypes.ItemClickEvent) => void;
onSelectOnFocusChanged: (e: CheckBoxTypes.ValueChangedEvent) => void;
onRtlModeChanged: (e: CheckBoxTypes.ValueChangedEvent) => void;
}
export default function Options({
orientation,
navigationMode,
selectOnFocus,
rtlMode,
onOrientationClick,
onNavigationModeClick,
onSelectOnFocusChanged,
onRtlModeChanged,
}: OptionsProps) {
return (
<>
<div className="caption">Options</div>
<div className="option">
<div>Orientation</div>
<ButtonGroup
id="orientation"
keyExpr="value"
items={orientations}
selectedItemKeys={[orientation]}
onItemClick={onOrientationClick}
/>
</div>
<div className="option">
<div>Navigation Mode</div>
<ButtonGroup
id="navigationMode"
keyExpr="value"
items={navigationModes}
selectedItemKeys={[navigationMode]}
onItemClick={onNavigationModeClick}
/>
</div>
<div className="option-separator"></div>
<div className="option">
<CheckBox
id="selectOnFocus"
text="Select step on focus"
value={selectOnFocus}
onValueChanged={onSelectOnFocusChanged}
/>
</div>
<div className="option">
<CheckBox
id="rtlMode"
text="Right-to-left mode"
value={rtlMode}
onValueChanged={onRtlModeChanged}
/>
</div>
</>
);
}
import React from 'react';
import { Stepper, Item } from 'devextreme-react/stepper';
import type { StepperTypes } from 'devextreme-react/stepper';
import type { Orientation } from 'devextreme-react/common';
import { steps } from './data.ts';
import type { StepperConfig } from './types.ts';
const stepperConfigs: StepperConfig[] = [
{
id: 'icons',
labelId: 'iconsLabel',
title: 'Icons and Labels',
fields: ['label', 'icon', 'optional'] as const,
},
{
id: 'numbers',
labelId: 'numbersLabel',
title: 'Numbers and Labels',
fields: ['label', 'optional'] as const,
},
{
id: 'customText',
labelId: 'customTextLabel',
title: 'Custom Text',
fields: ['text'] as const,
},
];
interface SteppersProps {
orientation: Orientation;
navigationMode: boolean;
selectOnFocus: boolean;
rtlMode: boolean;
}
export default function Steppers({
orientation,
navigationMode,
selectOnFocus,
rtlMode,
}: SteppersProps) {
return (
<>
{stepperConfigs.map(({ id, labelId, title, fields }: StepperConfig) => (
<div key={id} className="stepper-wrapper">
<div id={labelId} className="stepper-label">{title}</div>
<Stepper
id={id}
elementAttr={{ 'aria-labelledby': labelId }}
defaultSelectedIndex={2}
orientation={orientation}
linear={navigationMode}
selectOnFocus={selectOnFocus}
rtlEnabled={rtlMode}
>
{steps.map((step: StepperTypes.Item, index: number) => {
const itemProps = fields.reduce((acc: Record<string, unknown>, field: keyof StepperTypes.Item): Record<string, unknown> => {
acc[field] = step[field];
return acc;
}, {});
return <Item key={index} {...itemProps} />;
})}
</Stepper>
</div>
))}
</>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import themes from 'devextreme/ui/themes';
import App from './App.tsx';
themes.initialized(() => {
ReactDOM.render(
<App />,
document.getElementById('app'),
);
});
import type { StepperTypes } from 'devextreme-react/stepper';
import type { StepperOrientation, StepperNavigationMode } from './types.ts';
export const steps: StepperTypes.Item[] = [
{
text: 'A',
label: 'Cart',
icon: 'cart',
},
{
text: 'B',
label: 'Shipping Info',
icon: 'clipboardtasklist',
},
{
text: 'C',
label: 'Promo Code',
icon: 'gift',
optional: true,
},
{
text: 'D',
label: 'Checkout',
icon: 'packagebox',
},
{
text: 'E',
label: 'Ordered',
icon: 'checkmarkcircle',
},
];
export const orientations: StepperOrientation[] = [
{ text: 'Horizontal', value: 'horizontal' },
{ text: 'Vertical', value: 'vertical' },
];
export const navigationModes: StepperNavigationMode[] = [
{ text: 'Non-linear', value: false },
{ text: 'Linear', value: true },
];
import type { Orientation } from 'devextreme-react/common';
import type { StepperTypes } from 'devextreme-react/stepper';
export type StepperOrientation = {
text: string;
value: Orientation;
};
export type StepperNavigationMode = {
text: string;
value: boolean;
};
export type StepperConfig = {
id: string;
labelId: string;
title: string;
fields: (keyof StepperTypes.Item)[];
};
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import { ButtonGroup } from 'devextreme-react/button-group';
import { CheckBox } from 'devextreme-react/check-box';
import { navigationModes, orientations } from './data.js';
export default function Options({
orientation,
navigationMode,
selectOnFocus,
rtlMode,
onOrientationClick,
onNavigationModeClick,
onSelectOnFocusChanged,
onRtlModeChanged,
}) {
return (
<>
<div className="caption">Options</div>
<div className="option">
<div>Orientation</div>
<ButtonGroup
id="orientation"
keyExpr="value"
items={orientations}
selectedItemKeys={[orientation]}
onItemClick={onOrientationClick}
/>
</div>
<div className="option">
<div>Navigation Mode</div>
<ButtonGroup
id="navigationMode"
keyExpr="value"
items={navigationModes}
selectedItemKeys={[navigationMode]}
onItemClick={onNavigationModeClick}
/>
</div>
<div className="option-separator"></div>
<div className="option">
<CheckBox
id="selectOnFocus"
text="Select step on focus"
value={selectOnFocus}
onValueChanged={onSelectOnFocusChanged}
/>
</div>
<div className="option">
<CheckBox
id="rtlMode"
text="Right-to-left mode"
value={rtlMode}
onValueChanged={onRtlModeChanged}
/>
</div>
</>
);
}
import React from 'react';
import { Stepper, Item } from 'devextreme-react/stepper';
import { steps } from './data.js';
const stepperConfigs = [
{
id: 'icons',
labelId: 'iconsLabel',
title: 'Icons and Labels',
fields: ['label', 'icon', 'optional'],
},
{
id: 'numbers',
labelId: 'numbersLabel',
title: 'Numbers and Labels',
fields: ['label', 'optional'],
},
{
id: 'customText',
labelId: 'customTextLabel',
title: 'Custom Text',
fields: ['text'],
},
];
export default function Steppers({
orientation, navigationMode, selectOnFocus, rtlMode,
}) {
return (
<>
{stepperConfigs.map(({
id, labelId, title, fields,
}) => (
<div
key={id}
className="stepper-wrapper"
>
<div
id={labelId}
className="stepper-label"
>
{title}
</div>
<Stepper
id={id}
elementAttr={{ 'aria-labelledby': labelId }}
defaultSelectedIndex={2}
orientation={orientation}
linear={navigationMode}
selectOnFocus={selectOnFocus}
rtlEnabled={rtlMode}
>
{steps.map((step, index) => {
const itemProps = fields.reduce((acc, field) => {
acc[field] = step[field];
return acc;
}, {});
return (
<Item
key={index}
{...itemProps}
/>
);
})}
</Stepper>
</div>
))}
</>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import themes from 'devextreme/ui/themes';
import App from './App.js';
themes.initialized(() => {
ReactDOM.render(<App />, document.getElementById('app'));
});
export const steps = [
{
text: 'A',
label: 'Cart',
icon: 'cart',
},
{
text: 'B',
label: 'Shipping Info',
icon: 'clipboardtasklist',
},
{
text: 'C',
label: 'Promo Code',
icon: 'gift',
optional: true,
},
{
text: 'D',
label: 'Checkout',
icon: 'packagebox',
},
{
text: 'E',
label: 'Ordered',
icon: 'checkmarkcircle',
},
];
export const orientations = [
{ text: 'Horizontal', value: 'horizontal' },
{ text: 'Vertical', value: 'vertical' },
];
export const navigationModes = [
{ text: 'Non-linear', value: false },
{ text: 'Linear', value: true },
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#app {
display: flex;
flex-direction: column;
}
.stepper-demo {
display: flex;
height: 580px;
gap: 20px;
}
.widget-container {
display: flex;
align-items: center;
justify-content: center;
width: calc(100% - 280px);
min-width: 320px;
overflow: clip;
gap: 20px;
}
.widget-wrapper {
display: inline-flex;
flex-direction: column;
align-items: center;
justify-content: center;
row-gap: 80px;
width: 100%;
height: 100%;
}
.widget-wrapper-vertical {
display: flex;
flex-direction: row;
justify-content: space-around;
}
.widget-wrapper-vertical .stepper-wrapper {
width: auto;
max-width: 33%;
}
.widget-wrapper-vertical .stepper-label {
text-align: center;
white-space: nowrap;
}
.widget-wrapper-vertical #customText {
width: auto;
}
.dx-stepper-vertical {
height: 400px;
width: 100%;
}
.stepper-wrapper {
width: 100%;
display: flex;
flex-direction: column;
align-items: center;
gap: 16px;
}
.stepper-label {
font-weight: 600;
}
.options {
display: flex;
flex-direction: column;
flex-shrink: 0;
width: 300px;
box-sizing: border-box;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
gap: 16px;
height: 100%;
}
.caption {
font-weight: 500;
font-size: 18px;
}
.option {
display: flex;
flex-direction: column;
row-gap: 4px;
}
.option-separator {
border-bottom: 1px solid var(--dx-color-border);
}
.dx-buttongroup .dx-button {
width: 50%;
}

<template>
<div class="stepper-demo">
<div class="widget-container">
<div :class="['widget-wrapper', 'widget-wrapper-' + orientation]">
<div
v-for="config in stepperConfigs"
:key="config.id"
class="stepper-wrapper"
>
<div
:id="config.labelId"
class="stepper-label"
>
{{ config.title }}
</div>
<DxStepper
:id="config.id"
:element-attr="{ 'aria-labelledby': config.labelId }"
:selected-index="2"
:orientation="orientation"
:linear="navigationMode"
:select-on-focus="selectOnFocus"
:rtl-enabled="rtlMode"
>
<DxItem
v-for="(step, index) in steps"
:key="index"
v-bind="getItemProps(step, config.fields)"
/>
</DxStepper>
</div>
</div>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<div>Orientation</div>
<DxButtonGroup
id="orientation"
key-expr="value"
:items="orientations"
:selected-item-keys="[orientation]"
@item-click="onOrientationClick"
/>
</div>
<div class="option">
<div>Navigation Mode</div>
<DxButtonGroup
id="navigationMode"
key-expr="value"
:items="navigationModes"
:selected-item-keys="[navigationMode]"
@item-click="onNavigationModeClick"
/>
</div>
<div class="option-separator"/>
<div class="option">
<DxCheckBox
id="selectOnFocus"
text="Select step on focus"
v-model:value="selectOnFocus"
/>
</div>
<div class="option">
<DxCheckBox
id="rtlMode"
text="Right-to-left mode"
v-model:value="rtlMode"
/>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import { DxStepper, DxItem } from 'devextreme-vue/stepper';
import { DxButtonGroup, type DxButtonGroupTypes } from 'devextreme-vue/button-group';
import { DxCheckBox } from 'devextreme-vue/check-box';
import { steps, orientations, navigationModes, type Step } from './data.ts';
type Fields = Array<keyof Step>;
const orientation = ref(orientations[0].value);
const navigationMode = ref(navigationModes[0].value);
const selectOnFocus = ref(true);
const rtlMode = ref(false);
function onOrientationClick(e: DxButtonGroupTypes.ItemClickEvent) {
orientation.value = e.itemData.value;
}
function onNavigationModeClick(e: DxButtonGroupTypes.ItemClickEvent) {
navigationMode.value = e.itemData.value;
}
const stepperConfigs = [
{
id: 'icons',
labelId: 'iconsLabel',
title: 'Icons and Labels',
fields: ['label', 'icon', 'optional'] as Fields,
},
{
id: 'numbers',
labelId: 'numbersLabel',
title: 'Numbers and Labels',
fields: ['label', 'optional'] as Fields,
},
{
id: 'customText',
labelId: 'customTextLabel',
title: 'Custom Text',
fields: ['text'] as Fields,
},
];
function getItemProps(step: Step, fields: Fields) {
return fields.reduce((acc, field) => {
if (field in step) {
acc[field] = step[field];
}
return acc;
}, {} as Record<string, unknown>);
}
</script>
<style scoped>
#app {
display: flex;
flex-direction: column;
}
.stepper-demo {
display: flex;
height: 580px;
gap: 20px;
}
.widget-container {
display: flex;
align-items: center;
justify-content: center;
width: calc(100% - 280px);
min-width: 320px;
overflow: clip;
gap: 20px;
}
.widget-wrapper {
display: inline-flex;
flex-direction: column;
align-items: center;
justify-content: center;
row-gap: 80px;
width: 100%;
height: 100%;
}
.widget-wrapper-vertical {
display: flex;
flex-direction: row;
justify-content: space-around;
}
.widget-wrapper-vertical .stepper-wrapper {
width: auto;
max-width: 33%;
}
.widget-wrapper-vertical .stepper-label {
text-align: center;
white-space: nowrap;
}
.widget-wrapper-vertical #customText {
width: auto;
}
.dx-stepper-vertical {
height: 400px;
width: 100%;
}
.stepper-wrapper {
width: 100%;
display: flex;
flex-direction: column;
align-items: center;
gap: 16px;
}
.stepper-label {
font-weight: 600;
}
.options {
display: flex;
flex-direction: column;
flex-shrink: 0;
width: 300px;
box-sizing: border-box;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
gap: 16px;
height: 100%;
}
.caption {
font-weight: 500;
font-size: 18px;
}
.option {
display: flex;
flex-direction: column;
row-gap: 4px;
}
.option-separator {
border-bottom: 1px solid var(--dx-color-border);
}
.dx-buttongroup .dx-button {
width: 50%;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import { type Orientation } from "devextreme-vue/common";
export interface Step {
text: string,
label: string,
icon: string,
optional?: boolean,
}
export const steps: Step[] = [
{
text: 'A',
label: 'Cart',
icon: 'cart',
},
{
text: 'B',
label: 'Shipping Info',
icon: 'clipboardtasklist',
},
{
text: 'C',
label: 'Promo Code',
icon: 'gift',
optional: true,
},
{
text: 'D',
label: 'Checkout',
icon: 'packagebox',
},
{
text: 'E',
label: 'Ordered',
icon: 'checkmarkcircle',
},
];
export const orientations: { text: string; value: Orientation }[] = [
{ text: 'Horizontal', value: 'horizontal' },
{ text: 'Vertical', value: 'vertical' },
];
export const navigationModes = [
{ text: 'Non-linear', value: false },
{ text: 'Linear', value: true },
];
import { createApp } from 'vue';
import themes from 'devextreme/ui/themes';
import App from './App.vue';
themes.initialized(() => createApp(App).mount('#app'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

<div class="stepper-demo">
<div class="widget-container">
<div class="widget-wrapper" [class]="'widget-wrapper-' + orientation">
<div class="stepper-wrapper">
<div id="iconsLabel" class="stepper-label">Icons and Labels</div>
<dx-stepper
id="icons"
[elementAttr]="{ 'aria-labelledby': 'iconsLabel' }"
[selectedIndex]="2"
[orientation]="orientation"
[linear]="navigationMode"
[selectOnFocus]="selectOnFocus"
[rtlEnabled]="rtlMode"
>
@for (step of steps; track step) {
<dxi-stepper-item
[label]="step.label"
[icon]="step.icon"
[optional]="step.optional"
></dxi-stepper-item>
}
</dx-stepper>
</div>
<div class="stepper-wrapper">
<div id="numbersLabel" class="stepper-label">Numbers and Labels</div>
<dx-stepper
id="numbers"
[elementAttr]="{ 'aria-labelledby': 'numbersLabel' }"
[selectedIndex]="2"
[orientation]="orientation"
[linear]="navigationMode"
[selectOnFocus]="selectOnFocus"
[rtlEnabled]="rtlMode"
>
@for (step of steps; track step) {
<dxi-stepper-item
[label]="step.label"
[optional]="step.optional"
></dxi-stepper-item>
}
</dx-stepper>
</div>
<div class="stepper-wrapper">
<div id="customTextLabel" class="stepper-label">Custom Text</div>
<dx-stepper
id="customText"
[elementAttr]="{ 'aria-labelledby': 'customTextLabel' }"
[selectedIndex]="2"
[orientation]="orientation"
[linear]="navigationMode"
[selectOnFocus]="selectOnFocus"
[rtlEnabled]="rtlMode"
>
@for (step of steps; track step) {
<dxi-stepper-item [text]="step.text"></dxi-stepper-item>
}
</dx-stepper>
</div>
</div>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<div>Orientation</div>
<dx-button-group
id="orientation"
keyExpr="value"
[items]="orientations"
[selectedItemKeys]="[orientation]"
(onItemClick)="onOrientationClick($event)"
/>
</div>
<div class="option">
<div>Navigation Mode</div>
<dx-button-group
id="navigationMode"
keyExpr="value"
[items]="navigationModes"
[selectedItemKeys]="[navigationMode]"
(onItemClick)="onNavigationModeClick($event)"
/>
</div>
<div class="option-separator"></div>
<div class="option">
<dx-check-box
id="selectOnFocus"
text="Select step on focus"
[value]="selectOnFocus"
(onValueChanged)="onSelectOnFocusChanged($event)"
/>
</div>
<div class="option">
<dx-check-box
id="rtlMode"
text="Right-to-left mode"
[value]="rtlMode"
(onValueChanged)="onRtlModeChanged($event)"
/>
</div>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxButtonGroupModule, type DxButtonGroupTypes } from 'devextreme-angular/ui/button-group';
import { DxCheckBoxModule, type DxCheckBoxTypes } from 'devextreme-angular/ui/check-box';
import { DxStepperModule, type DxStepperTypes } from 'devextreme-angular/ui/stepper';
import { AppService } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxStepperModule,
DxButtonGroupModule,
DxCheckBoxModule,
],
})
export class AppComponent {
steps: DxStepperTypes.Item[];
orientations: any[];
navigationModes: any[];
orientation: string;
navigationMode: boolean;
selectOnFocus: boolean = true;
rtlMode: boolean = false;
constructor(private readonly appService: AppService) {
this.steps = this.appService.getSteps();
this.orientations = this.appService.getOrientations();
this.navigationModes = this.appService.getNavigationModes();
this.orientation = this.orientations[0].value;
this.navigationMode = this.navigationModes[0].value;
}
onOrientationClick(e: DxButtonGroupTypes.ItemClickEvent) {
this.orientation = e.itemData.value;
}
onNavigationModeClick(e: DxButtonGroupTypes.ItemClickEvent) {
this.navigationMode = e.itemData.value;
}
onSelectOnFocusChanged(e: DxCheckBoxTypes.ValueChangedEvent) {
this.selectOnFocus = e.value;
}
onRtlModeChanged(e: DxCheckBoxTypes.ValueChangedEvent) {
this.rtlMode = e.value;
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
AppService,
],
});
::ng-deep demo-app {
display: flex;
flex-direction: column;
}
::ng-deep .stepper-demo {
display: flex;
height: 580px;
gap: 20px;
}
::ng-deep .widget-container {
display: flex;
align-items: center;
justify-content: center;
width: calc(100% - 280px);
min-width: 320px;
overflow: clip;
gap: 20px;
}
::ng-deep .widget-wrapper {
display: inline-flex;
flex-direction: column;
align-items: center;
justify-content: center;
row-gap: 80px;
width: 100%;
height: 100%;
}
::ng-deep .widget-wrapper-vertical {
display: flex;
flex-direction: row;
justify-content: space-around;
}
::ng-deep .widget-wrapper-vertical .stepper-wrapper {
width: auto;
max-width: 33%;
}
::ng-deep .widget-wrapper-vertical .stepper-label {
text-align: center;
white-space: nowrap;
}
::ng-deep .widget-wrapper-vertical #customText {
width: auto;
}
::ng-deep .dx-stepper-vertical {
height: 400px;
width: 100%;
}
::ng-deep .stepper-wrapper {
width: 100%;
display: flex;
flex-direction: column;
align-items: center;
gap: 16px;
}
::ng-deep .stepper-label {
font-weight: 600;
}
::ng-deep .options {
display: flex;
flex-direction: column;
flex-shrink: 0;
width: 300px;
box-sizing: border-box;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
gap: 16px;
height: 100%;
}
::ng-deep .caption {
font-weight: 500;
font-size: 18px;
}
::ng-deep .option {
display: flex;
flex-direction: column;
row-gap: 4px;
}
::ng-deep .option-separator {
border-bottom: 1px solid var(--dx-color-border);
}
::ng-deep .dx-buttongroup .dx-button {
width: 50%;
}
import { Injectable } from "@angular/core";
import { type DxStepperTypes } from 'devextreme-angular/ui/stepper';
@Injectable({
providedIn: "root",
})
export class AppService {
steps: DxStepperTypes.Item[] = [];
orientations = [];
navigationModes = [];
constructor() {
this.steps = [
{
text: "A",
label: "Cart",
icon: "cart",
},
{
text: "B",
label: "Shipping Info",
icon: "clipboardtasklist",
},
{
text: "C",
label: "Promo Code",
icon: "gift",
optional: true,
},
{
text: "D",
label: "Checkout",
icon: "packagebox",
},
{
text: "E",
label: "Ordered",
icon: "checkmarkcircle",
},
];
this.orientations = [
{ text: "Horizontal", value: "horizontal" },
{ text: "Vertical", value: "vertical" },
];
this.navigationModes = [
{ text: 'Non-linear', value: false },
{ text: 'Linear', value: true },
];
}
getSteps(): DxStepperTypes.Item[] {
return this.steps;
}
getOrientations() {
return this.orientations;
}
getNavigationModes() {
return this.navigationModes;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.0.2"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>